﻿
namespace LandformsClassifier
{
    /// <summary>
    /// Represents an area (in most cases square area) of the terrain (grid).
    /// </summary>
    class Area
    {
        public LandformsE landform;
        public bool visited = false;
        public bool containsEdge = false;
        public int x, y; // coordinates (indeces to the grid) of the left upper corner
        public int i, j; // indeces to the array of areas
        public int width, height; // width and height of the area
        public int pointsNo; // number of points in the area
        public float avgZ; // average value of z-coordinates of all points in the area
        public int flatPointNo; // number of points classified as a flat
        public int slopePointNo; // number of points classified as a slope
        public int edgePointNo; // number of points classified as a terrain edge, without opposite aspect points
        public int oppAspectPointNo; // number of points classified as an opposite aspect points
        public int otherPointNo; // number of points that were not assigned to any category
        public float ratioFlat; // ratio of flat points to all points
        public float ratioSlope; // ratio of slope points to all points
        public float ratioOtherPoints; // ratio of not classified points to all points

        public Area(int luCornerX, int luCornerY, int i, int j, int sizeX, int sizeY, int pointsNo, float sumZ, int flatPoints, int slopePoints, int edgePoints, int oppAspectPoints, int otherPoints)
        {
            this.x = luCornerX;
            this.y = luCornerY;
            this.i = i;
            this.j = j;
            this.width = sizeX;
            this.height = sizeY;
            this.pointsNo = pointsNo;
            this.avgZ = sumZ / pointsNo;
            this.flatPointNo = flatPoints;
            this.slopePointNo = slopePoints;
            this.edgePointNo = edgePoints;
            this.oppAspectPointNo = oppAspectPoints;
            this.otherPointNo = otherPoints;
            this.ratioFlat = flatPoints / (float)pointsNo;
            this.ratioSlope = slopePoints / (float)pointsNo;
            this.ratioOtherPoints = otherPoints / (float)pointsNo;

            if (edgePoints > 1 || oppAspectPoints > 1) // if the area contains at least 2 terrain edge points
            {
                this.containsEdge = true;
            }
        }
    }
}
