﻿using System;

namespace LandformsClassifier
{
    /// <summary>
    /// This class serves to convert degrees to the specific direction.
    /// </summary>
    public static class Direction
    {
        /** Convert degrees to the 1 of 8 directions */
        public static Dir GetDirection(float degrees)
        {
            // Northeast
            if ((degrees > 22.5) && (degrees <= 67.5))
                return Dir.NE;

            // East
            if ((degrees > 67.5) && (degrees <= 112.5))
                return Dir.E;

            // Southeast
            if ((degrees > 112.5) && (degrees <= 157.5))
                return Dir.SE;

            // South
            if ((degrees > 157.5) && (degrees <= 202.5))
                return Dir.S;

            // Southwest
            if ((degrees > 202.5) && (degrees <= 247.5))
                return Dir.SW;

            // West
            if ((degrees > 247.5) && (degrees <= 292.5))
                return Dir.W;

            // Northwest
            if ((degrees > 292.5) && (degrees <= 337.5))
                return Dir.NW;

            // North
            if (((degrees > 337.5) && (degrees <= 360)) || ((degrees >= 0) && (degrees <= 22.5)))
                return Dir.N;

            // Flat
            if (Math.Abs(degrees + 1) < 0.0001)
                return Dir.FLAT;

            return Dir.UNKNOWN;
        }

        /** Convert degrees to the 1 of 4 directions */
        public static Dir GetDirection2(float degrees)
        {
            // East
            if ((degrees > 45) && (degrees <= 135))
                return Dir.E;

            // South
            if ((degrees > 135) && (degrees <= 225))
                return Dir.S;

            // West
            if ((degrees > 225) && (degrees <= 315))
                return Dir.W;

            // North
            if (((degrees > 315) && (degrees <= 360)) || ((degrees >= 0) && (degrees <= 45)))
                return Dir.N;

            // Flat
            if (Math.Abs(degrees + 1) < 0.0001)
                return Dir.FLAT;

            return Dir.UNKNOWN;
        }
    }

    /** This enum contains directions of the slope */
    public enum Dir {
        NW, N, NE, E, SE, S, SW, W, FLAT, UNKNOWN
    }

}
