﻿
namespace LandformsClassifier
{
    /// <summary>
    /// Represents a single point from terrain defined by coordinates x, y, z.
    /// It also contains pointer to another point which is in the same cell of the grid.
    /// </summary>
    class Point
    {
        // Coordinates of the point
        public float x, y, z;
        // Slope parameter in degrees
        public float slope;
        // Aspect parameter in degrees
        public float aspectDeg;
        // Aspect parameter in direction
        public Dir aspectDir;
        // Profile curvature
        public float profileCurvature;
        // Plan curvature
        public float planCurvature;
        // Total Homogeneity index
        public float homogeneity;
        // H value of z-coordinate
        public float Hz;
        // H value of slope
        public float Hs;
        // H value of aspect
        public float Ha;
        // H value of profile curvature
        public float Hpr;
        // H value of plan curvature
        public float Hpl;
        // Category of the point
        public TerrainFeatureE terFeature;
        // Pointer to another point on the same coordinates         
        public Point next = null;
        // Count of points on this position
        public int counter = 1;

        public Point(float x, float y, float z)
        {
            this.x = x;
            this.y = y;
            this.z = z;
        }
    }
}
